package com.demo.whousemywifi.Ipcalculator;

import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.text.Editable;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.SpinnerAdapter;
import android.widget.TextView;
import android.widget.Toast;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;


import com.demo.whousemywifi.AdAdmob;
import com.demo.whousemywifi.R;

import com.demo.whousemywifi.common.PrefManager;


public class Ipv4calculator_Activity extends AppCompatActivity {
    private int CurrentBits;
    private String CurrentIP;
   
    Spinner bitlengthSpinner;
    Button calculate;
    EditText inIpAddress;
    
    TextView msgAddressRange;
    TextView msgIPBinaryHost;
    TextView msgIPBinaryNetmask;
    TextView msgIPBinaryNetwork;
    TextView msgMaximumAddresses;
    TextView msgWildcard;
    PrefManager prefManager;
    Button reset;
    
    Spinner subnetmaskSpinner;
    Toolbar toolbar;

 


    
    @Override 
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        setContentView(R.layout.activity_ip_v4);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);

        AdAdmob adAdmob = new AdAdmob( this);
        adAdmob.BannerAd((RelativeLayout) findViewById(R.id.banner), this);
        adAdmob.FullscreenAd_Counter(this);



        this.toolbar = toolbar;
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowTitleEnabled(false);
        getSupportActionBar().setHomeAsUpIndicator(R.drawable.toolbar_back_black_dark_icon);
        
        
       
        PrefManager prefManager = new PrefManager(this);
        this.prefManager = prefManager;
  
        this.inIpAddress = (EditText) findViewById(R.id.ipaddress);
        this.calculate = (Button) findViewById(R.id.calculate);
        this.reset = (Button) findViewById(R.id.reset);
        this.msgAddressRange = (TextView) findViewById(R.id.address_range);
        this.msgMaximumAddresses = (TextView) findViewById(R.id.maximum_addresses);
        this.msgWildcard = (TextView) findViewById(R.id.wildcard);
        this.msgIPBinaryNetwork = (TextView) findViewById(R.id.ip_binary_network);
        this.msgIPBinaryHost = (TextView) findViewById(R.id.ip_binary_host);
        this.msgIPBinaryNetmask = (TextView) findViewById(R.id.ip_binary_netmask);
        this.bitlengthSpinner = (Spinner) findViewById(R.id.bitlength);
        this.subnetmaskSpinner = (Spinner) findViewById(R.id.subnetmask);
        ArrayAdapter<CharSequence> createFromResource = ArrayAdapter.createFromResource(this, R.array.bitlengths, R.layout.spinner_item);
        createFromResource.setDropDownViewResource(17367049);
        this.bitlengthSpinner.setAdapter((SpinnerAdapter) createFromResource);
        ArrayAdapter<CharSequence> createFromResource2 = ArrayAdapter.createFromResource(this, R.array.subnets, R.layout.spinner_item);
        createFromResource2.setDropDownViewResource(17367049);
        this.subnetmaskSpinner.setAdapter((SpinnerAdapter) createFromResource2);
        this.calculate.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                ((InputMethodManager) Ipv4calculator_Activity.this.getSystemService(Context.INPUT_METHOD_SERVICE)).toggleSoftInput(1, 0);
                Ipv4calculator_Activity.this.doCalculate();
            }
        });
        this.reset.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Ipv4calculator_Activity.this.CurrentIP = "";
                Ipv4calculator_Activity.this.CurrentBits = 24;
                Ipv4calculator_Activity.this.updateFields();
                Ipv4calculator_Activity.this.ClearResults();
            }
        });
        this.bitlengthSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() { 
            @Override 
            public void onNothingSelected(AdapterView<?> adapterView) {
            }

            @Override 
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long j) {
                Ipv4calculator_Activity.this.UpdateSubnetmaskFromBitlength();
                Ipv4calculator_Activity.this.updateResults(true);
            }
        });
        this.subnetmaskSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() { 
            @Override 
            public void onNothingSelected(AdapterView<?> adapterView) {
            }

            @Override 
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long j) {
                Ipv4calculator_Activity.this.UpdateBitlengthFromSubnetmask();
                Ipv4calculator_Activity.this.updateResults(true);
            }
        });
        this.bitlengthSpinner.setSelection(this.CurrentBits - 1);
        this.subnetmaskSpinner.setSelection(this.CurrentBits - 1);
    }

    
    public void updateFields() {
        this.inIpAddress.setText(this.CurrentIP);
        this.bitlengthSpinner.setSelection(this.CurrentBits - 1);
    }

    public void UpdateSubnetmaskFromBitlength() {
        this.subnetmaskSpinner.setSelection(this.bitlengthSpinner.getSelectedItemPosition());
    }

    public void UpdateBitlengthFromSubnetmask() {
        this.bitlengthSpinner.setSelection(this.subnetmaskSpinner.getSelectedItemPosition());
    }

    
    public void doCalculate() {
        if (updateResults(true)) {
            return;
        }
        this.msgAddressRange.setText("Bad IP format");
    }

    public static String convertIPIntDec2StringBinary(int i) {
        String binaryString = Integer.toBinaryString(i);
        int length = binaryString.length();
        if (length < 32) {
            for (int i2 = 0; i2 < 32 - length; i2++) {
                binaryString = "0" + binaryString;
            }
        }
        return binaryString.substring(0, 8) + "." + binaryString.substring(8, 16) + "." + binaryString.substring(16, 24) + "." + binaryString.substring(24, 32);
    }

    public boolean updateResults(boolean z) {
        Editable text = this.inIpAddress.getText();
        if (text == null) {
            return false;
        }
        String charSequence = text.toString();
        try {
            int stringIPtoInt = stringIPtoInt(charSequence);
            String str = (String) this.bitlengthSpinner.getSelectedItem();
            if (str == null) {
                return false;
            }
            int parseInt = Integer.parseInt(str.substring(1));
            int i = (1 << (32 - parseInt)) - 1;
            int i2 = ~i;
            int i3 = stringIPtoInt & i2;
            String IntIPToString = IntIPToString(i3);
            String IntIPToString2 = IntIPToString(i3 | i);
            int i4 = i > 0 ? i - 1 : 0;
            String IntIPToString3 = IntIPToString(i);
            String convertIPIntDec2StringBinary = convertIPIntDec2StringBinary(stringIPtoInt);
            String convertIPIntDec2StringBinary2 = convertIPIntDec2StringBinary(i2);
            this.CurrentIP = charSequence;
            this.CurrentBits = parseInt;
            if (z) {
                TextView textView = this.msgAddressRange;
                textView.setText(IntIPToString + " - " + IntIPToString2);
                this.msgMaximumAddresses.setText(String.format("%d", Integer.valueOf(i4)));
                this.msgWildcard.setText(IntIPToString3);
                if (parseInt >= 24) {
                    parseInt += 3;
                } else if (parseInt >= 16) {
                    parseInt += 2;
                } else if (parseInt >= 8) {
                    parseInt++;
                }
                String substring = convertIPIntDec2StringBinary.substring(0, parseInt);
                String substring2 = convertIPIntDec2StringBinary.substring(parseInt);
                this.msgIPBinaryNetwork.setText(substring);
                this.msgIPBinaryHost.setText(substring2);
                this.msgIPBinaryNetmask.setText(convertIPIntDec2StringBinary2);
                PreferenceManager.getDefaultSharedPreferences(this).getBoolean("notification", false);
            }
            return true;
        } catch (Exception unused) {
            ClearResults();
            return false;
        }
    }

    public static int stringIPtoInt(String str) throws Exception {
        String[] split = str.split("\\.", 4);
        if (split.length != 4) {
            throw new Exception();
        }
        int i = 0;
        for (String str2 : split) {
            if (str2.length() < 1) {
                throw new Exception();
            }
            try {
                int parseInt = Integer.parseInt(str2);
                if (parseInt > 255) {
                    throw new Exception();
                }
                i = (i << 8) | parseInt;
            } catch (NumberFormatException unused) {
                throw new Exception();
            }
        }
        return i;
    }

    private String IntIPToString(int i) {
        return String.format("%d.%d.%d.%d", Integer.valueOf((((-16777216) & i) >> 24) & 255), Integer.valueOf((16711680 & i) >> 16), Integer.valueOf((65280 & i) >> 8), Integer.valueOf(i & 255));
    }

    
    public void ClearResults() {
        this.msgAddressRange.setText("");
        this.msgMaximumAddresses.setText("");
        this.msgWildcard.setText("");
        this.msgIPBinaryNetwork.setText("");
        this.msgIPBinaryHost.setText("");
        this.msgIPBinaryNetmask.setText("");
    }

    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override 
    public void onBackPressed() {
        super.onBackPressed();
 
        finish();
    }

    @Override 
    public boolean onOptionsItemSelected(MenuItem menuItem) {
        switch (menuItem.getItemId()) {
            case 16908332:
                onBackPressed();
                return true;


            case R.id.rate :
                if (isOnline()) {
                    Intent intent3 = new Intent("android.intent.action.VIEW", Uri.parse("http://play.google.com/store/apps/details?id=" + getPackageName()));
                    intent3.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    intent3.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(intent3);
                } else {
                    Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                }
                return true;
            case R.id.share :
                if (isOnline()) {
                    Intent intent4 = new Intent("android.intent.action.SEND");
                    intent4.setType("text/plain");
                    intent4.putExtra("android.intent.extra.TEXT", "Hi! I'm using a Who Use My Wi-Fi application. Check it out:http://play.google.com/store/apps/details?id=" + getPackageName());
                    intent4.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(Intent.createChooser(intent4, "Share with Friends"));
                } else {
                    Toast makeText2 = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText2.setGravity(17, 0, 0);
                    makeText2.show();
                }
                return true;
            default:
                return super.onOptionsItemSelected(menuItem);
        }
    }

    public boolean isOnline() {
        NetworkInfo activeNetworkInfo = ((ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
        return activeNetworkInfo != null && activeNetworkInfo.isConnectedOrConnecting();
    }
}
