package com.demo.whousemywifi.Ipcalculator;

import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.text.Editable;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.SpinnerAdapter;
import android.widget.TextView;
import android.widget.Toast;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;


import java.math.BigInteger;
import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.UnknownHostException;

import com.demo.whousemywifi.AdAdmob;
import com.demo.whousemywifi.R;

import com.demo.whousemywifi.common.PrefManager;


public class Ipv6calculator_Activity extends AppCompatActivity {
    private int CurrentBitsIPv6;
    private String CurrentIPv6;
   
    Button calculate;
    EditText inIpAddress;
    Spinner ipv6SubnetmasksSpinner;
    
    TextView msgAddressRange;
    TextView msgInfo;
    TextView msgMaximumAddresses;
    MulticastAddress[] multicastAddresses = {new MulticastAddress("ff02::1", R.string.allnodes), new MulticastAddress("ff02::2", R.string.allrouters), new MulticastAddress("ff02::9", R.string.allriprouters), new MulticastAddress("ff05::101", R.string.allntpservers), new MulticastAddress("ff05::1:3", R.string.alldhcpservers)};
    PrefManager prefManager;
    Button reset;
    
    Toolbar toolbar;

    
    
    public class MulticastAddress {
        String address;
        int description;

        public MulticastAddress(String str, int i) {
            this.address = str;
            this.description = i;
        }
    }

 



    
    @Override 
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        setContentView(R.layout.activity_ip_v6);



        AdAdmob adAdmob = new AdAdmob( this);
        adAdmob.BannerAd((RelativeLayout) findViewById(R.id.banner), this);
        adAdmob.FullscreenAd_Counter(this);


        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        this.toolbar = toolbar;
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowTitleEnabled(false);
        getSupportActionBar().setHomeAsUpIndicator(R.drawable.toolbar_back_black_dark_icon);
        
        
       
        PrefManager prefManager = new PrefManager(this);
        this.prefManager = prefManager;
  
        this.inIpAddress = (EditText) findViewById(R.id.ipv6address);
        this.calculate = (Button) findViewById(R.id.ipv6calculate);
        this.reset = (Button) findViewById(R.id.ipv6reset);
        this.ipv6SubnetmasksSpinner = (Spinner) findViewById(R.id.ipv6subnetmasks);
        this.msgAddressRange = (TextView) findViewById(R.id.v6address_range);
        this.msgMaximumAddresses = (TextView) findViewById(R.id.v6maximum_addresses);
        this.msgInfo = (TextView) findViewById(R.id.v6info);
        ArrayAdapter<CharSequence> createFromResource = ArrayAdapter.createFromResource(this, R.array.ipv6subnetmasks, R.layout.spinner_item);
        createFromResource.setDropDownViewResource(17367049);
        this.ipv6SubnetmasksSpinner.setAdapter((SpinnerAdapter) createFromResource);
        this.calculate.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                ((InputMethodManager) Ipv6calculator_Activity.this.getSystemService(Context.INPUT_METHOD_SERVICE)).toggleSoftInput(1, 0);
                Ipv6calculator_Activity.this.doCalculate();
            }
        });
        this.reset.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Ipv6calculator_Activity.this.CurrentIPv6 = "";
                Ipv6calculator_Activity.this.CurrentBitsIPv6 = 24;
                Ipv6calculator_Activity.this.updateFields();
                Ipv6calculator_Activity.this.ClearResults();
            }
        });
        this.ipv6SubnetmasksSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() { 
            @Override 
            public void onNothingSelected(AdapterView<?> adapterView) {
            }

            @Override 
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long j) {
                Ipv6calculator_Activity.this.updateResults(true);
            }
        });
        this.ipv6SubnetmasksSpinner.setSelection(this.CurrentBitsIPv6 - 1);
    }

    
    public void doCalculate() {
        if (updateResults(true)) {
            return;
        }
        this.msgAddressRange.setText("Bad IP format");
    }

    
    public void ClearResults() {
        this.msgAddressRange.setText("");
        this.msgMaximumAddresses.setText("");
        this.msgInfo.setText("");
    }

    
    public void updateFields() {
        this.inIpAddress.setText(this.CurrentIPv6);
        this.ipv6SubnetmasksSpinner.setSelection(this.CurrentBitsIPv6 - 1);
    }

    private static InetAddress bigIntToIPv6Address(BigInteger bigInteger) throws UnknownHostException {
        byte[] bArr = new byte[16];
        byte[] byteArray = bigInteger.toByteArray();
        if (byteArray.length > 16 && (byteArray.length != 17 || byteArray[0] != 0)) {
            throw new UnknownHostException("invalid IPv6 address (too big)");
        }
        if (byteArray.length == 16) {
            return InetAddress.getByAddress(byteArray);
        }
        if (byteArray.length == 17) {
            System.arraycopy(byteArray, 1, bArr, 0, 16);
        } else {
            System.arraycopy(byteArray, 0, bArr, 16 - byteArray.length, byteArray.length);
        }
        return InetAddress.getByAddress(bArr);
    }

    private String addStringWithSpace(String str, String str2) {
        if (str.length() != 0) {
            str = str + ", ";
        }
        return str + str2;
    }

    public boolean updateResults(boolean z) {
        BigInteger subtract;
        Editable text = this.inIpAddress.getText();
        if (text == null) {
            return false;
        }
        String charSequence = text.toString();
        try {
            byte[] ipStringToBytes = InetAddresses.ipStringToBytes(charSequence);
            if (ipStringToBytes == null) {
                return false;
            }
            InetAddress byAddress = InetAddress.getByAddress(ipStringToBytes);
            boolean z2 = byAddress instanceof Inet6Address;
            BigInteger bigInteger = new BigInteger(byAddress.getAddress());
            int selectedItemPosition = this.ipv6SubnetmasksSpinner.getSelectedItemPosition() + 1;
            BigInteger subtract2 = BigInteger.ONE.shiftLeft(128 - selectedItemPosition).subtract(BigInteger.ONE);
            BigInteger and = subtract2.xor(new BigInteger("ffffffffffffffffffffffffffffffff", 16)).and(bigInteger);
            and.toByteArray();
            InetAddress bigIntToIPv6Address = bigIntToIPv6Address(and);
            InetAddress bigIntToIPv6Address2 = bigIntToIPv6Address(and.or(subtract2));
            if (subtract2.equals(BigInteger.ZERO)) {
                subtract = BigInteger.ZERO;
            } else {
                subtract = subtract2.subtract(BigInteger.ONE);
            }
            String addStringWithSpace = byAddress.isAnyLocalAddress() ? addStringWithSpace("", getString(R.string.any_local)) : "";
            if (byAddress.isLinkLocalAddress()) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.link_local));
            }
            if (byAddress.isLoopbackAddress()) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.loopback));
            }
            if (byAddress.isMCGlobal()) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.mcglobal));
            }
            if (byAddress.isMCLinkLocal()) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.mclink_local));
            }
            if (byAddress.isMCNodeLocal()) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.mcnode_local));
            }
            if (byAddress.isMCOrgLocal()) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.mcorg_local));
            }
            if (byAddress.isMCSiteLocal()) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.mcsite_local));
            }
            if (byAddress.isMulticastAddress()) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.multicast));
                MulticastAddress[] multicastAddressArr = this.multicastAddresses;
                int length = multicastAddressArr.length;
                int i = 0;
                while (true) {
                    if (i >= length) {
                        break;
                    }
                    MulticastAddress multicastAddress = multicastAddressArr[i];
                    if (byAddress.getHostAddress().equals(InetAddress.getByAddress(InetAddresses.ipStringToBytes(multicastAddress.address)).getHostAddress())) {
                        addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(multicastAddress.description));
                        break;
                    }
                    i++;
                }
            }
            if (InetAddresses.isMappedIPv4Address(charSequence)) {
                addStringWithSpace = addStringWithSpace(addStringWithSpace, getString(R.string.mappedipv4));
            }
            TextView textView = this.msgAddressRange;
            textView.setText(bigIntToIPv6Address.getHostAddress() + " - " + bigIntToIPv6Address2.getHostAddress());
            this.msgMaximumAddresses.setText(subtract.toString());
            this.msgInfo.setText(addStringWithSpace);
            this.CurrentIPv6 = charSequence;
            this.CurrentBitsIPv6 = selectedItemPosition;
            return true;
        } catch (NumberFormatException e) {
            e.printStackTrace();
            ClearResults();
            return false;
        } catch (UnknownHostException e2) {
            e2.printStackTrace();
            ClearResults();
            return false;
        }
    }

    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override 
    public void onBackPressed() {
        super.onBackPressed();
 
        finish();
    }

    @Override 
    public boolean onOptionsItemSelected(MenuItem menuItem) {
        switch (menuItem.getItemId()) {
            case 16908332:
                onBackPressed();
                return true;


            case R.id.rate :
                if (isOnline()) {
                    Intent intent3 = new Intent("android.intent.action.VIEW", Uri.parse("http://play.google.com/store/apps/details?id=" + getPackageName()));
                    intent3.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    intent3.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(intent3);
                } else {
                    Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                }
                return true;
            case R.id.share :
                if (isOnline()) {
                    Intent intent4 = new Intent("android.intent.action.SEND");
                    intent4.setType("text/plain");
                    intent4.putExtra("android.intent.extra.TEXT", "Hi! I'm using a Who Use My Wi-Fi application. Check it out:http://play.google.com/store/apps/details?id=" + getPackageName());
                    intent4.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(Intent.createChooser(intent4, "Share with Friends"));
                } else {
                    Toast makeText2 = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText2.setGravity(17, 0, 0);
                    makeText2.show();
                }
                return true;
            default:
                return super.onOptionsItemSelected(menuItem);
        }
    }

    public boolean isOnline() {
        NetworkInfo activeNetworkInfo = ((ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
        return activeNetworkInfo != null && activeNetworkInfo.isConnectedOrConnecting();
    }
}
