package com.demo.whousemywifi.pingTools;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import androidx.appcompat.widget.AppCompatTextView;
import androidx.recyclerview.widget.RecyclerView;
import java.util.ArrayList;
import com.demo.whousemywifi.R;


public class CustomPingAdapter extends RecyclerView.Adapter<CustomPingAdapter.Holder> {
    Context context;
    LayoutInflater inflter;
    ArrayList<String> time;
    int val = 1;

    
    public class Holder extends RecyclerView.ViewHolder {
        LinearLayout linBorderView;
        AppCompatTextView txtPingNumber;
        AppCompatTextView txtPingResultByte;

        public Holder(View view) {
            super(view);
            this.txtPingNumber = (AppCompatTextView) view.findViewById(R.id.txtPingNumber);
            this.txtPingResultByte = (AppCompatTextView) view.findViewById(R.id.txtPingResultByte);
            this.linBorderView = (LinearLayout) view.findViewById(R.id.linBorderView);
        }
    }

    public CustomPingAdapter(Context context, ArrayList<String> arrayList) {
        this.context = context;
        this.time = arrayList;
        Log.i("ContentValues", "CustomPingAdapter: " + arrayList.size());
        this.inflter = LayoutInflater.from(context);
    }

    @Override 
    public Holder onCreateViewHolder(ViewGroup viewGroup, int i) {
        return new Holder(LayoutInflater.from(this.context).inflate(R.layout.ping_list_layout_item, viewGroup, false));
    }

    public int setImage(int i) {
        switch (i) {
            case 1:
                this.val++;
                return R.drawable.color_1;
            case 2:
                this.val++;
                return R.drawable.color_2;
            case 3:
                this.val++;
                return R.drawable.color_3;
            case 4:
                this.val++;
                return R.drawable.color_4;
            case 5:
                this.val++;
                return R.drawable.color_5;
            case 6:
                this.val = 1;
                return R.drawable.color_6;
            default:
                return R.drawable.color_1;
        }
    }

    @Override 
    public void onBindViewHolder(Holder holder, int i) {
        AppCompatTextView appCompatTextView = holder.txtPingNumber;
        appCompatTextView.setText("#" + (getItemCount() - i));
        StringBuilder sb = new StringBuilder();
        sb.append(String.valueOf(this.time.get(i)));
        holder.txtPingResultByte.setText(sb.toString());
        holder.linBorderView.setBackgroundResource(setImage(this.val));
    }

    @Override 
    public long getItemId(int i) {
        return this.time.size();
    }

    @Override 
    public int getItemCount() {
        ArrayList<String> arrayList = this.time;
        if (arrayList == null) {
            return 0;
        }
        return arrayList.size();
    }
}
