package com.demo.whousemywifi.pingTools;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.InputFilter;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Toast;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.util.ArrayList;
import java.util.Objects;
import java.util.regex.Pattern;

import com.demo.whousemywifi.AdAdmob;
import com.demo.whousemywifi.R;


public class PingToolsActivity extends AppCompatActivity {
    private static final Pattern IPV6_HEX_COMPRESSED_PATTERN = Pattern.compile("^((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)::((?:[0-9A-Fa-f]{1,4}(?::[0-9A-Fa-f]{1,4})*)?)$");
    private static final Pattern IPV6_STD_PATTERN = Pattern.compile("^(?:[0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}$");
    Activity activity;
    ArrayAdapter<String> adapter;
    ArrayList<Float> arrayListPingList;
    AsyncTask asyncTask;
    EditText cntedt;
    Context context;
    int count;
    int delay;
    Boolean flag = Boolean.FALSE;
    String host;
    LinearLayout linNext;
    ArrayList<String> ms;
    RecyclerView recyclerViewPingList;
    EditText timeedt;
    Toolbar toolbar;
    String txtHost;
    AutoCompleteTextView txtHostUrl;

    @Override 
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        setContentView(R.layout.ping_activity_new2);


        AdAdmob adAdmob = new AdAdmob( this);
        adAdmob.BannerAd((RelativeLayout) findViewById(R.id.banner), this);
        adAdmob.FullscreenAd_Counter(this);



        this.context = this;
        this.activity = this;
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        this.toolbar = toolbar;
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowTitleEnabled(false);
        getSupportActionBar().setHomeAsUpIndicator(R.drawable.toolbar_back_black_dark_icon);
        this.arrayListPingList = new ArrayList<>();
        RecyclerView recyclerView = (RecyclerView) findViewById(R.id.recyclerViewPingList);
        this.recyclerViewPingList = recyclerView;
        recyclerView.setHasFixedSize(true);
        this.recyclerViewPingList.setNestedScrollingEnabled(true);
        this.recyclerViewPingList.setLayoutManager(new LinearLayoutManager(getApplicationContext()));
        this.linNext = (LinearLayout) findViewById(R.id.linNext);
        this.txtHostUrl = (AutoCompleteTextView) findViewById(R.id.txtHostUrl);
        String[] strArr = MyUtility.getping((Activity) this.context);
        if (strArr != null) {
            ArrayAdapter<String> arrayAdapter = new ArrayAdapter<>(this.context, 17367043, strArr);
            this.adapter = arrayAdapter;
            this.txtHostUrl.setAdapter(arrayAdapter);
        }
        this.timeedt = (EditText) findViewById(R.id.edtTime);
        EditText editText = (EditText) findViewById(R.id.edTCount);
        this.cntedt = editText;
        editText.setFilters(new InputFilter[]{new InputFilterMinMax("0", "500", this.context, "Enter Valid Range From 0 - 500")});
        this.timeedt.setFilters(new InputFilter[]{new InputFilterMinMax("0", "10000", this.context, "Enter Valid Range From 0 - 1000")});
        this.txtHost = this.txtHostUrl.getText().toString();
        this.linNext.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                try {
                    PingToolsActivity.this.ms = new ArrayList<>();
                } catch (Exception e) {
                    e.printStackTrace();
                    return;
                }
                if (ConnectivityReceiver.isConnected()) {
                    Object systemService = PingToolsActivity.this.context.getSystemService(Context.INPUT_METHOD_SERVICE);
                    Objects.requireNonNull(systemService);
                    ((InputMethodManager) systemService).hideSoftInputFromWindow(PingToolsActivity.this.txtHostUrl.getWindowToken(), 0);
                    PingToolsActivity pingToolsActivity = PingToolsActivity.this;
                    pingToolsActivity.host = pingToolsActivity.txtHostUrl.getText().toString().trim();
                    if (!PingToolsActivity.this.host.isEmpty()) {
                        PingToolsActivity.this.host.length();
                        PingToolsActivity pingToolsActivity2 = PingToolsActivity.this;
                        pingToolsActivity2.count = Integer.parseInt(pingToolsActivity2.cntedt.getText().toString());
                        PingToolsActivity pingToolsActivity3 = PingToolsActivity.this;
                        pingToolsActivity3.delay = Integer.parseInt(pingToolsActivity3.timeedt.getText().toString());
                        if (PingToolsActivity.this.ms.size() > 1 && PingToolsActivity.this.arrayListPingList.size() > 1) {
                            PingToolsActivity.this.ms.clear();
                            PingToolsActivity.this.arrayListPingList.clear();
                        }
                        PingToolsActivity.this.asyncTask = new initDb();
                        if (PingToolsActivity.this.host != null && MyUtility.addping((Activity) PingToolsActivity.this.context, PingToolsActivity.this.host) && PingToolsActivity.this.host != null) {
                            if (PingToolsActivity.this.adapter != null) {
                                try {
                                    PingToolsActivity.this.adapter.add(PingToolsActivity.this.host);
                                    PingToolsActivity.this.adapter.notifyDataSetChanged();
                                } catch (Exception e2) {
                                    e2.printStackTrace();
                                }
                            } else {
                                try {
                                    String[] strArr2 = MyUtility.getping((Activity) PingToolsActivity.this.context);
                                    if (strArr2 != null) {
                                        PingToolsActivity.this.adapter = new ArrayAdapter<>(PingToolsActivity.this.context, 17367043, strArr2);
                                        PingToolsActivity.this.txtHostUrl.setAdapter(PingToolsActivity.this.adapter);
                                    }
                                } catch (Exception e3) {
                                    e3.printStackTrace();
                                }
                            }
                            return;
                        }
                        PingToolsActivity.this.asyncTask.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, new Object[0]);
                        return;
                    }
                    Toast makeText = Toast.makeText(PingToolsActivity.this.getApplicationContext(), "Please Enter Valid Host", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                    return;
                }
                Toast makeText2 = Toast.makeText(PingToolsActivity.this.getApplicationContext(), "No Internet Connection", Toast.LENGTH_SHORT);
                makeText2.setGravity(17, 0, 0);
                makeText2.show();
            }
        });
    }

    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override 
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override 
    public boolean onOptionsItemSelected(MenuItem menuItem) {
        switch (menuItem.getItemId()) {
            case 16908332:
                onBackPressed();
                return true;

            case R.id.rate :
                if (isOnline()) {
                    Intent intent3 = new Intent("android.intent.action.VIEW", Uri.parse("http://play.google.com/store/apps/details?id=" + getPackageName()));
                    intent3.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    intent3.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(intent3);
                } else {
                    Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                }
                return true;
            case R.id.share :
                if (isOnline()) {
                    Intent intent4 = new Intent("android.intent.action.SEND");
                    intent4.setType("text/plain");
                    intent4.putExtra("android.intent.extra.TEXT", "Hi! I'm using a Who Use My Wi-Fi application. Check it out:http://play.google.com/store/apps/details?id=" + getPackageName());
                    intent4.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(Intent.createChooser(intent4, "Share with Friends"));
                } else {
                    Toast makeText2 = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText2.setGravity(17, 0, 0);
                    makeText2.show();
                }
                return true;
            default:
                return super.onOptionsItemSelected(menuItem);
        }
    }

    public boolean isOnline() {
        NetworkInfo activeNetworkInfo = ((ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
        return activeNetworkInfo != null && activeNetworkInfo.isConnectedOrConnecting();
    }

    public synchronized boolean getflag() {
        return this.flag.booleanValue();
    }

    public void doPing(int i, int i2, String str) throws IOException, InterruptedException {
        int i3 = 0;
        while (i3 < i) {
            try {
            } catch (Exception e) {
                e.printStackTrace();
            }
            if (getflag()) {
                return;
            }
            try {
                Thread.sleep(i2);
            } catch (InterruptedException e2) {
                e2.printStackTrace();
            }
            ping(str, i2);
            i3++;
        }
    }

    @Override 
    public void onStop() {
        super.onStop();
        try {
            AsyncTask asyncTask = this.asyncTask;
            if (asyncTask == null || asyncTask.getStatus() != AsyncTask.Status.RUNNING) {
                return;
            }
            this.asyncTask.cancel(true);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static boolean isIPv6HexCompressedAddress(String str) {
        return str != null && IPV6_HEX_COMPRESSED_PATTERN.matcher(str).matches();
    }

    public static boolean isIPv6Address(String str) {
        return isIPv6StdAddress(str) || isIPv6HexCompressedAddress(str);
    }

    public static boolean isIPv6StdAddress(String str) {
        return str != null && IPV6_STD_PATTERN.matcher(str).matches();
    }

    public int ping(String str, int i) throws IOException, InterruptedException {
        String[] split;
        Runtime runtime = Runtime.getRuntime();
        StringBuilder sb = new StringBuilder();
        int max = Math.max(i / 1000, 1);
        int max2 = Math.max(128, 1);
        InetAddress byName = InetAddress.getByName(str);
        String hostAddress = byName.getHostAddress();
        String str2 = "ping";
        if (hostAddress == null) {
            hostAddress = byName.getHostName();
        } else if (isIPv6Address(hostAddress)) {
            str2 = "ping6";
        }
        Process exec = runtime.exec(str2 + " -c 1 -W " + max + " -t " + max2 +  " " + hostAddress);
        exec.waitFor();
        int exitValue = exec.exitValue();
        if (exitValue == 0) {
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(exec.getInputStream()));
            while (true) {
                String readLine = bufferedReader.readLine();
                if (readLine == null) {
                    split = sb.toString().split("\\n");
                    if (split.length > 1) {
                        try {
                            break;
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                } else {
                    sb.append(readLine);
                    sb.append("\n");
                }
            }
            String[] finalSplit = split;
            runOnUiThread(new Runnable() { 
                @Override 
                public void run() {
                    PingToolsActivity.this.ms.add(0, finalSplit[1].toString());
                    Log.i("ContentValues", "run: " + PingToolsActivity.this.ms);
                    CustomPingAdapter customPingAdapter = new CustomPingAdapter(PingToolsActivity.this.context, PingToolsActivity.this.ms);
                    PingToolsActivity.this.recyclerViewPingList.setAdapter(customPingAdapter);
                    customPingAdapter.notifyDataSetChanged();
                }
            });
        }
        return exitValue;
    }

    
    public class initDb extends AsyncTask<Object, Object, Void> {
        ProgressDialog mDialog;

        @Override 
        public void onPreExecute() {
        }

        initDb() {
            this.mDialog = new ProgressDialog(PingToolsActivity.this.context);
        }

        @Override 
        public Void doInBackground(Object... objArr) {
            try {
                isCancelled();
                try {
                    PingToolsActivity pingToolsActivity = PingToolsActivity.this;
                    pingToolsActivity.doPing(pingToolsActivity.count, PingToolsActivity.this.delay, PingToolsActivity.this.host);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                return null;
            } catch (Exception e2) {
                e2.printStackTrace();
                return null;
            }
        }

        @Override 
        public void onPostExecute(Void r1) {
            try {
                this.mDialog.dismiss();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override 
    public void onResume() {
        super.onResume();
    }
}
