package com.demo.whousemywifi.routerInfo;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Toast;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.AppCompatTextView;
import androidx.appcompat.widget.Toolbar;


import com.demo.whousemywifi.AdAdmob;
import com.demo.whousemywifi.R;

import com.demo.whousemywifi.common.PrefManager;
import com.demo.whousemywifi.routerPage.Router_Page;
import com.demo.whousemywifi.wifiRouterPassword.Router_password;


public class RouterInfoMainActivity extends AppCompatActivity {
    Activity activity;
   
    Context context;
    RelativeLayout layout;
    LinearLayout linRouterAdmin;
    LinearLayout linRouterInfo;
    LinearLayout linRouterPasswordList;
    PrefManager prefManager;
    
    Toolbar toolbar;
    AppCompatTextView txtGateway;

    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override 
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override 
    public boolean onOptionsItemSelected(MenuItem menuItem) {
        switch (menuItem.getItemId()) {
            case 16908332:
                onBackPressed();
                return true;


            case R.id.rate :
                if (isOnline()) {
                    Intent intent3 = new Intent("android.intent.action.VIEW", Uri.parse("http://play.google.com/store/apps/details?id=" + getPackageName()));
                    intent3.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    intent3.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(intent3);
                } else {
                    Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                }
                return true;
            case R.id.share :
                if (isOnline()) {
                    Intent intent4 = new Intent("android.intent.action.SEND");
                    intent4.setType("text/plain");
                    intent4.putExtra("android.intent.extra.TEXT", "Hi! I'm using a Who Use My Wi-Fi application. Check it out:http://play.google.com/store/apps/details?id=" + getPackageName());
                    intent4.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(Intent.createChooser(intent4, "Share with Friends"));
                } else {
                    Toast makeText2 = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText2.setGravity(17, 0, 0);
                    makeText2.show();
                }
                return true;
            default:
                return super.onOptionsItemSelected(menuItem);
        }
    }

    public boolean isOnline() {
        NetworkInfo activeNetworkInfo = ((ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
        return activeNetworkInfo != null && activeNetworkInfo.isConnectedOrConnecting();
    }

    
    @Override 
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        setContentView(R.layout.activity_router_info_main);

        AdAdmob adAdmob = new AdAdmob( this);
        adAdmob.BannerAd((RelativeLayout) findViewById(R.id.banner), this);
        adAdmob.FullscreenAd_Counter(this);

        this.context = this;
        this.activity = this;
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        this.toolbar = toolbar;
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowTitleEnabled(false);
        getSupportActionBar().setHomeAsUpIndicator(R.drawable.toolbar_back_black_dark_icon);
        
        
       
        
        PrefManager prefManager = new PrefManager(this);
        this.prefManager = prefManager;
        this.txtGateway = (AppCompatTextView) findViewById(R.id.txtGateway);
        this.linRouterPasswordList = (LinearLayout) findViewById(R.id.linRouterPasswordList);
        this.linRouterAdmin = (LinearLayout) findViewById(R.id.linRouterAdmin);
        this.linRouterInfo = (LinearLayout) findViewById(R.id.linRouterInfo);
        setDetails();
        this.linRouterPasswordList.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Intent intent = new Intent(RouterInfoMainActivity.this, Router_password.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                RouterInfoMainActivity.this.startActivity(intent);
            }
        });
        this.linRouterAdmin.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Intent intent = new Intent(RouterInfoMainActivity.this, Router_Page.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                RouterInfoMainActivity.this.startActivity(intent);
            }
        });
        this.linRouterInfo.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Intent intent = new Intent(RouterInfoMainActivity.this, WifiRouterInfoActivity.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                RouterInfoMainActivity.this.startActivity(intent);
            }
        });
    }

    private void setDetails() {
        Wireless wireless = new Wireless(this);
        if (wireless.isEnabled() && wireless.isConnectedWifi()) {
            try {
                if (Build.VERSION.SDK_INT >= 21) {
                    String.valueOf(wireless.getWifiInfo().getFrequency());
                }
                AppCompatTextView appCompatTextView = this.txtGateway;
                appCompatTextView.setText("Gateway : " + wireless.getGetWay());
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
