package com.demo.whousemywifi.speedtest;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Path;
import android.util.AttributeSet;
import android.view.View;
import androidx.recyclerview.widget.ItemTouchHelper;
import com.demo.whousemywifi.R;


public class SpeedGauge extends View {
    private static final int BIGGERTICKEVERY = 5;
    private static final float RADSxTICK = 0.06283186f;
    private static final int TICKS = 50;
    double curvalue;
    double endvalue;
    private Paint indicatorpaint;
    int sizeoftext;
    private Paint tickspaint;

    public float carib(double d) {
        float f;
        float f2;
        if (d <= 5.0d) {
            f = (float) d;
            f2 = 5.0f;
        } else if (d <= 10.0d) {
            f = (float) d;
            f2 = 3.0f;
        } else if (d <= 12.0d) {
            f = (float) d;
            f2 = 2.5833333f;
        } else if (d < 14.0d) {
            f = (float) d;
            f2 = 2.2857144f;
        } else if (d < 16.0d) {
            f = (float) d;
            f2 = 2.0625f;
        } else if (d < 18.0d) {
            f = (float) d;
            f2 = 1.8888888f;
        } else if (d < 20.0d) {
            f = (float) d;
            f2 = 1.75f;
        } else if (d <= 22.0d) {
            f = (float) d;
            f2 = 1.6363636f;
        } else if (d < 24.0d) {
            f = (float) d;
            f2 = 1.5416666f;
        } else if (d < 26.0d) {
            f = (float) d;
            f2 = 1.4615384f;
        } else if (d < 28.0d) {
            f = (float) d;
            f2 = 1.3928572f;
        } else if (d < 30.0d) {
            f = (float) d;
            f2 = 1.3333334f;
        } else if (d <= 32.0d) {
            f = (float) d;
            f2 = 1.28125f;
        } else if (d < 34.0d) {
            f = (float) d;
            f2 = 1.2352941f;
        } else if (d < 36.0d) {
            f = (float) d;
            f2 = 1.1944444f;
        } else if (d < 38.0d) {
            f = (float) d;
            f2 = 1.1578947f;
        } else if (d < 40.0d) {
            f = (float) d;
            f2 = 1.125f;
        } else if (d <= 42.0d) {
            f = (float) d;
            f2 = 1.0952381f;
        } else if (d < 44.0d) {
            f = (float) d;
            f2 = 1.0681819f;
        } else if (d < 46.0d) {
            f = (float) d;
            f2 = 1.0434783f;
        } else if (d < 48.0d) {
            f = (float) d;
            f2 = 1.0208334f;
        } else if (d >= 50.0d) {
            return 0.0f;
        } else {
            f = (float) d;
            f2 = 1.0f;
        }
        return f * f2;
    }

    public void setEndValue(double d) {
        this.endvalue = d;
        invalidate();
    }

    public void setValue(double d) {
        this.curvalue = d;
        invalidate();
    }

    public int getSizeoftext() {
        return this.sizeoftext;
    }

    public void setSizeoftext(int i) {
        this.sizeoftext = i;
    }

    private void init() {
        Paint paint = new Paint(1);
        this.tickspaint = paint;
        paint.setColor(getResources().getColor(R.color.Black));
        this.tickspaint.setStrokeWidth(10.0f);
        this.tickspaint.setTextSize(getResources().getDimensionPixelSize(R.dimen.textsize));
        Paint paint2 = new Paint(1);
        this.indicatorpaint = paint2;
        paint2.setColor(getResources().getColor(R.color.TickColor));
        this.indicatorpaint.setStrokeWidth(8.0f);
        this.indicatorpaint.setStyle(Paint.Style.FILL);
    }

    public SpeedGauge(Context context) {
        super(context);
        this.curvalue = 0.0d;
        this.endvalue = 50.0d;
        init();
    }

    public SpeedGauge(Context context, AttributeSet attributeSet) {
        super(context, attributeSet);
        this.curvalue = 0.0d;
        this.endvalue = 50.0d;
        init();
    }

    public SpeedGauge(Context context, AttributeSet attributeSet, int i) {
        super(context, attributeSet, i);
        this.curvalue = 0.0d;
        this.endvalue = 50.0d;
        init();
    }

    @Override 
    protected void onMeasure(int i, int i2) {
        int i3;
        int i4 = 0;
        int mode = View.MeasureSpec.getMode(i);
        int size = View.MeasureSpec.getSize(i);
        View.MeasureSpec.getMode(i2);
        View.MeasureSpec.getSize(i2);
        if (mode == 1073741824) {
            i4 = size / 2;
        } else if (mode == Integer.MIN_VALUE) {
            i4 = size / 2;
        } else {
            size = 500;
            i3 = ItemTouchHelper.Callback.DEFAULT_SWIPE_ANIMATION_DURATION;
            setMeasuredDimension(size, i3);
        }
        i3 = i4 + 50;
        setMeasuredDimension(size, i3);
    }

    @Override 
    public void draw(Canvas canvas) {
        int i;
        int i2;
        Canvas canvas2 = canvas;
        super.draw(canvas);
        float width = getWidth() / 2;
        float f = width - 10.0f;
        float f2 = width - 20.0f;
        float f3 = width - 50.0f;
        float width2 = getWidth() / 2;
        float height = getHeight() - 20.0f;
        int i3 = 5;
        int i4 = 50;
        int i5 = 5;
        int i6 = 50;
        int i7 = 0;
        int i8 = 0;
        while (i8 <= i4) {
            float f4 = f2;
            double d = i8 * RADSxTICK;
            float f5 = f;
            float cos = (float) Math.cos(d);
            float sin = (float) Math.sin(d);
            if (i7 == i3 || i7 == 0) {
                int i9 = i5;
                int i10 = i6;
                i = i8;
                canvas.drawLine((cos * f4) + width2, height - (sin * f4), (cos * width) + width2, height - (sin * width), this.tickspaint);
                if (i10 >= 10) {
                    canvas2 = canvas;
                    canvas2.drawText("" + i10, ((cos * f3) + width2) - ((50 - i) * 0.4f), (height - (sin * f3)) + 10.0f, this.tickspaint);
                    i6 = i10 + (-10);
                    i5 = i9;
                } else {
                    canvas2 = canvas;
                    canvas2.drawText("" + i9, ((cos * f3) + width2) - ((50 - i) * 0.4f), (height - (sin * f3)) + 10.0f, this.tickspaint);
                    i5 = i9 + (-1);
                    i6 = i10;
                }
                i2 = 0;
            } else {
                i2 = i7;
                i = i8;
                canvas.drawLine((cos * f5) + width2, height - (sin * f5), (cos * width) + width2, height - (sin * width), this.tickspaint);
                i6 = i6;
                i5 = i5;
                canvas2 = canvas;
            }
            i8 = i + 1;
            i7 = i2 + 1;
            f2 = f4;
            f = f5;
            i4 = 50;
            i3 = 5;
        }
        float f6 = f2;
        double carib = 3.141592653589793d - (((float) (carib(this.curvalue) / this.endvalue)) * 3.141592653589793d);
        float cos2 = (float) Math.cos(carib);
        float sin2 = (float) Math.sin(carib);
        canvas.drawLine(width2 - 20.0f, height, width2 + (cos2 * f3), height - (sin2 * f3), this.indicatorpaint);
        double d2 = carib + 0.05235987755982988d;
        double d3 = carib - 0.05235987755982988d;
        Path path = new Path();
        path.reset();
        float cos3 = (((float) Math.cos(d2)) * f3) + width2;
        float sin3 = height - (((float) Math.sin(d2)) * f3);
        path.moveTo(cos3, sin3);
        path.lineTo((((float) Math.cos(d3)) * f3) + width2, height - (((float) Math.sin(d3)) * f3));
        path.lineTo((cos2 * f6) + width2, height - (sin2 * f6));
        path.lineTo(cos3, sin3);
        canvas2.drawPath(path, this.indicatorpaint);
    }
}
