package com.demo.whousemywifi.speedtest;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;


public class SpeedTestMini {
    private static final long BUFFERSIZE = 256;
    private static final long REPORTINTERVAL = 1024;
    private static final long UPLOAD_SIZE = 2097152;
    private String host;
    private int port;
    private ProgressReportListener report = null;

    
    static class C05601 implements ProgressReportListener {
        @Override 
        public void reportCurrentDownloadProgress(long j) {
        }

        @Override 
        public void reportCurrentDownloadSpeed(long j) {
        }

        @Override 
        public void reportCurrentUploadPercentage(long j) {
        }

        @Override 
        public void reportCurrentUploadSpeed(long j) {
        }

        C05601() {
        }
    }

    public static void main(String[] strArr) {
        SpeedTestMini speedTestMini = new SpeedTestMini("192.168.80.17", 80);
        speedTestMini.setProgressReportListener(new C05601());
        try {
            System.out.println(speedTestMini.doDownloadtest());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public SpeedTestMini(String str, int i) {
        this.host = str;
        this.port = i;
    }

    public void setProgressReportListener(ProgressReportListener progressReportListener) {
        this.report = progressReportListener;
    }

    public long doUploadtest() throws UnknownHostException, IOException {
        Socket socket = new Socket(this.host, this.port);
        PrintWriter printWriter = new PrintWriter(socket.getOutputStream());
        printWriter.println("POST /speedtest/upload.php HTTP/1.1");
        printWriter.println("Host: " + this.host);
        printWriter.println("Cache-Control: max-age=0");
        printWriter.println("Content-Length: 2097152");
        printWriter.println("Connection: close");
        printWriter.println("");
        printWriter.flush();
        long currentTimeMillis = System.currentTimeMillis();
        byte[] bArr = new byte[256];
        for (int i = 0; i < BUFFERSIZE; i++) {
            bArr[i] = (byte) (Math.random() * 255.0d);
        }
        long j = 1;
        while (true) {
            long j2 = 0;
            while (j < UPLOAD_SIZE) {
                socket.getOutputStream().write(bArr);
                long j3 = 256;
                j2 += j3;
                j += j3;
                if (j2 >= 1024) {
                    long currentTimeMillis2 = (long) ((8 * j) / ((System.currentTimeMillis() - currentTimeMillis) / 1000.0d));
                    ProgressReportListener progressReportListener = this.report;
                    if (progressReportListener != null) {
                        progressReportListener.reportCurrentUploadSpeed(currentTimeMillis2);
                    }
                    this.report.reportCurrentUploadPercentage((100 * j) / UPLOAD_SIZE);
                    System.currentTimeMillis();
                }
            }
            long nanoTime = (long) ((j * 8) / ((System.nanoTime() - currentTimeMillis) / 1000.0d));
            socket.close();
            return nanoTime;
        }
    }

    public long doDownloadtest() throws UnknownHostException, IOException {
        Socket socket = new Socket(this.host, this.port);
        PrintWriter printWriter = new PrintWriter(socket.getOutputStream());
        printWriter.println("GET /speedtest/random2000x2000.jpg HTTP/1.1");
        printWriter.println("Host: " + this.host);
        printWriter.println("Cache-Control: max-age=0");
        printWriter.println("Connection: close");
        printWriter.println("");
        printWriter.flush();
        socket.getInputStream().read();
        long currentTimeMillis = System.currentTimeMillis();
        byte[] bArr = new byte[1048576];
        long j = 1;
        while (true) {
            long j2 = 0;
            do {
                long read = socket.getInputStream().read(bArr);
                if (read == -1) {
                    long currentTimeMillis2 = (long) ((j * 8) / ((System.currentTimeMillis() - currentTimeMillis) / 1000.0d));
                    socket.close();
                    return currentTimeMillis2;
                }
                j2 += read;
                j += read;
            } while (j2 < 32768);
            long currentTimeMillis3 = (long) ((j * 8) / ((System.currentTimeMillis() - currentTimeMillis) / 1000.0d));
            ProgressReportListener progressReportListener = this.report;
            if (progressReportListener != null) {
                progressReportListener.reportCurrentDownloadSpeed(currentTimeMillis3);
            }
            this.report.reportCurrentDownloadProgress((100 * j) / 7907740);
            System.currentTimeMillis();
        }
    }
}
