package com.demo.whousemywifi.speedtest;

import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.net.wifi.WifiManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.animation.AlphaAnimation;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.android.volley.AuthFailureError;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
  
  
 
 
import java.io.IOException;
import java.io.PrintStream;
import java.lang.reflect.Method;
import java.net.InetAddress;
import java.net.Socket;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.json.JSONException;
import org.json.JSONObject;

import com.demo.whousemywifi.AdAdmob;
import com.demo.whousemywifi.R;

import com.demo.whousemywifi.common.PrefManager;


public class SpeedTest_Activity extends AppCompatActivity {
   
    private AlphaAnimation anim;
    private String best;
    private Button buttonTest;
    private ConnectivityManager connManager;
    private Context context;
    private ProgressDialog dialog;
    String down;
    private TextView download;
    private SpeedGauge gauge;
    ImageView img_mob;
    ImageView img_mob_active;
    ImageView img_wifi;
    ImageView img_wifi_active;
    RelativeLayout layout;
    AlertDialog levelDialog;
    LinearLayout lin_mob;
    LinearLayout lin_wifi;
    private LocationManager mLocationManager;
    NetworkInfo mWifi;
    boolean mb_flag;
    NetworkInfo.State mobile;
    private ArrayList<ArrayList<Float>> nearestlist;
    String png;
    PrefManager prefManager;
    private ImageView reset;
    private ScrollView scrollView;
    private TextView serverTag;
    private ArrayList<Object> serverXML;
    
    private String tmp;
    Toolbar toolbar;
    TextView txt_dmb;
    TextView txt_mob;
    TextView txt_mob_test;
    TextView txt_umb;
    TextView txt_wifi;
    TextView txt_wifi_test;
    String up;
    private TextView upload;
    boolean wf_flag;
    NetworkInfo.State wifi;
    boolean wifi_ft;

    String country = "";
    boolean flag_mb_set = false;
    boolean flag_wf_set = false;
    private String host = "";
    boolean mobileDataEnabled = false;
    boolean spinner_flag = false;

    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override 
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override 
    public boolean onOptionsItemSelected(MenuItem menuItem) {
        switch (menuItem.getItemId()) {
            case 16908332:
                onBackPressed();
                return true;
           

            case R.id.rate :
                if (isOnline()) {
                    Intent intent3 = new Intent("android.intent.action.VIEW", Uri.parse("http://play.google.com/store/apps/details?id=" + getPackageName()));
                    intent3.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    intent3.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(intent3);
                } else {
                    Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                }
                return true;
            case R.id.share :
                if (isOnline()) {
                    Intent intent4 = new Intent("android.intent.action.SEND");
                    intent4.setType("text/plain");
                    intent4.putExtra("android.intent.extra.TEXT", "Hi! I'm using a Who Use My Wi-Fi application. Check it out:http://play.google.com/store/apps/details?id=" + getPackageName());
                    intent4.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(Intent.createChooser(intent4, "Share with Friends"));
                } else {
                    Toast makeText2 = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText2.setGravity(17, 0, 0);
                    makeText2.show();
                }
                return true;
            default:
                return super.onOptionsItemSelected(menuItem);
        }
    }

    public boolean isOnline() {
        NetworkInfo activeNetworkInfo = ((ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
        return activeNetworkInfo != null && activeNetworkInfo.isConnectedOrConnecting();
    }

 



    
    @Override 
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        setContentView(R.layout.speedtest_activity2);


        AdAdmob adAdmob = new AdAdmob( this);
        adAdmob.BannerAd((RelativeLayout) findViewById(R.id.banner), this);
        adAdmob.FullscreenAd_Counter(this);






        this.context = this;
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        this.toolbar = toolbar;
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowTitleEnabled(false);
        getSupportActionBar().setHomeAsUpIndicator(R.drawable.toolbar_back_black_dark_icon);
        
        
       
        
        PrefManager prefManager = new PrefManager(this);
        this.prefManager = prefManager;
        SpeedGauge speedGauge = new SpeedGauge(this);
        this.serverXML = FeedXmlUtil.feed(this);
        this.download = (TextView) findViewById(R.id.textViewDownload);
        this.upload = (TextView) findViewById(R.id.textViewUpload);
        this.buttonTest = (Button) findViewById(R.id.buttonTest);
        ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        this.connManager = connectivityManager;
        this.mWifi = connectivityManager.getNetworkInfo(1);
        this.mLocationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        AlphaAnimation alphaAnimation = new AlphaAnimation(0.0f, 1.0f);
        this.anim = alphaAnimation;
        alphaAnimation.setDuration(1000L);
        this.anim.setStartOffset(20L);
        this.anim.setRepeatMode(2);
        this.anim.setRepeatCount(-1);
        this.download.setTextColor(getResources().getColor(R.color.Black));
        this.upload.setTextColor(getResources().getColor(R.color.Black));
        this.up = getResources().getString(R.string.upload);
        this.down = getResources().getString(R.string.download);
        this.png = getResources().getString(R.string.ping);
        this.img_mob = (ImageView) findViewById(R.id.img_mob);
        this.img_wifi = (ImageView) findViewById(R.id.img_wifi);
        this.img_mob_active = (ImageView) findViewById(R.id.img_mob_active);
        this.img_wifi_active = (ImageView) findViewById(R.id.img_wifi_active);
        this.lin_mob = (LinearLayout) findViewById(R.id.lin_mob);
        this.lin_wifi = (LinearLayout) findViewById(R.id.lin_wifi);
        this.txt_dmb = (TextView) findViewById(R.id.txt_dmb);
        this.txt_umb = (TextView) findViewById(R.id.txt_umb);
        this.txt_mob_test = (TextView) findViewById(R.id.txt_mob_test);
        this.txt_wifi_test = (TextView) findViewById(R.id.txt_wifi_test);
        this.img_wifi_active. setVisibility(View.VISIBLE);
        this.img_mob_active.setVisibility(View.INVISIBLE);
        this.lin_mob.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                SpeedTest_Activity.this.img_mob.setImageResource(R.drawable.speed_test_mobile_selected);
                SpeedTest_Activity.this.img_wifi.setImageResource(R.drawable.speed_test_wifi_unselected);
                SpeedTest_Activity.this.img_wifi_active.setVisibility(View.INVISIBLE);
                SpeedTest_Activity.this.img_mob_active. setVisibility(View.VISIBLE);
                if (SpeedTest_Activity.this.mobileDataEnabled && SpeedTest_Activity.this.wf_flag) {
                    final ProgressDialog show = ProgressDialog.show(SpeedTest_Activity.this, "Connecting Cellular", "Please wait...", true);
                    ((WifiManager) SpeedTest_Activity.this.getApplicationContext().getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(false);
                    new Handler().postDelayed(new Runnable() { 
                        @Override 
                        public void run() {
                            show.dismiss();
                        }
                    }, 3000L);
                    SpeedTest_Activity.this.mb_flag = true;
                    SpeedTest_Activity.this.wf_flag = false;
                    SpeedTest_Activity.this.mbSet();
                } else if (SpeedTest_Activity.this.mobileDataEnabled && SpeedTest_Activity.this.wf_flag) {
                    final ProgressDialog show2 = ProgressDialog.show(SpeedTest_Activity.this, "Connecting Cellular", "Please wait...", true);
                    ((WifiManager) SpeedTest_Activity.this.getApplicationContext().getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(false);
                    new Handler().postDelayed(new Runnable() { 
                        @Override 
                        public void run() {
                            show2.dismiss();
                        }
                    }, 3000L);
                    SpeedTest_Activity.this.mb_flag = true;
                    SpeedTest_Activity.this.wf_flag = false;
                    SpeedTest_Activity.this.mbSet();
                } else {
                    new AlertDialog.Builder(SpeedTest_Activity.this).setTitle("Cellular Error").setOnCancelListener(new C02118()).setMessage("Please Check Your Cellular Connection and Try Again").setCancelable(true).setNeutralButton("OK", new C02107()).show();
                }
            }
        });
        this.lin_wifi.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                SpeedTest_Activity.this.img_mob.setImageResource(R.drawable.speed_test_mobile_unselected);
                SpeedTest_Activity.this.img_wifi.setImageResource(R.drawable.speed_test_wifi_selected);
                SpeedTest_Activity.this.img_wifi_active. setVisibility(View.VISIBLE);
                SpeedTest_Activity.this.img_mob_active.setVisibility(View.INVISIBLE);
                SpeedTest_Activity.this.txt_mob_test.setTextColor(Color.parseColor("#b4b4b4"));
                SpeedTest_Activity.this.txt_wifi_test.setTextColor(Color.parseColor("#4d4d4d"));
                if (SpeedTest_Activity.this.wifi == NetworkInfo.State.CONNECTED || SpeedTest_Activity.this.wifi == NetworkInfo.State.CONNECTING || SpeedTest_Activity.this.wf_flag) {
                    SpeedTest_Activity.this.wf_flag = true;
                    SpeedTest_Activity.this.wfSet();
                } else if (SpeedTest_Activity.this.wifi == NetworkInfo.State.CONNECTED || SpeedTest_Activity.this.wifi == NetworkInfo.State.CONNECTING || SpeedTest_Activity.this.wf_flag) {
                    SpeedTest_Activity.this.wf_flag = true;
                    SpeedTest_Activity.this.wfSet();
                } else {
                    AlertDialog.Builder builder = new AlertDialog.Builder(SpeedTest_Activity.this);
                    builder.setTitle("No Wifi Connection");
                    builder.setMessage("Do you need to open wifi ?");
                    builder.setPositiveButton("YES", new C02139());
                    builder.setNegativeButton("NO", new DialogInterface.OnClickListener() { 
                        @Override 
                        public void onClick(DialogInterface dialogInterface, int i) {
                            SpeedTest_Activity.this.mbSet();
                            dialogInterface.dismiss();
                        }
                    });
                    builder.create().show();
                }
            }
        });
        DisplayMetrics displayMetrics = new DisplayMetrics();
        try {
            getWindowManager().getDefaultDisplay().getRealMetrics(displayMetrics);
        } catch (NoSuchMethodError unused) {
            getWindowManager().getDefaultDisplay().getMetrics(displayMetrics);
        }
        speedGauge.setSizeoftext((int) (((displayMetrics.xdpi + displayMetrics.ydpi) / 2.0f) * 0.0f));
        this.gauge = (SpeedGauge) findViewById(R.id.speedGauge1);
        this.mobileDataEnabled = false;
        ConnectivityManager connectivityManager2 = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        try {
            Method declaredMethod = Class.forName(connectivityManager2.getClass().getName()).getDeclaredMethod("getMobileDataEnabled", new Class[0]);
            declaredMethod.setAccessible(true);
            this.mobileDataEnabled = ((Boolean) declaredMethod.invoke(connectivityManager2, new Object[0])).booleanValue();
        } catch (Exception unused2) {
        }
        this.buttonTest.setText(getResources().getString(R.string.start_test));
        this.buttonTest.setOnClickListener(new C02041());
        if (this.mWifi.isConnected()) {
            wfSet();
            this.flag_wf_set = true;
            this.flag_mb_set = false;
            setTextView();
            this.wf_flag = true;
            this.wifi_ft = true;
            ReadDataFromDB();
        } else if (this.mobileDataEnabled) {
            mbSet();
            this.flag_wf_set = false;
            this.flag_mb_set = true;
            setTextView();
            this.wifi_ft = false;
            this.mb_flag = true;
            ReadDataFromDB();
        } else {
            showErrorConnection();
        }
    }

    
    class C02041 implements View.OnClickListener {
        C02041() {
        }

        @Override 
        public void onClick(View view) {
            SpeedTest_Activity.this.buttonTest.setText(SpeedTest_Activity.this.getResources().getString(R.string.testing));
            SpeedTest_Activity.this.buttonTest.setEnabled(false);
            AlphaAnimation alphaAnimation = new AlphaAnimation(0.0f, 1.0f);
            alphaAnimation.setDuration(500L);
            SpeedTest_Activity.this.buttonTest.startAnimation(alphaAnimation);
            new SpeedTestLatency().execute(new String[0]);
        }
    }

    
    class C02107 implements DialogInterface.OnClickListener {
        @Override 
        public void onClick(DialogInterface dialogInterface, int i) {
        }

        C02107() {
        }
    }

    
    class C02118 implements DialogInterface.OnCancelListener {
        @Override 
        public void onCancel(DialogInterface dialogInterface) {
        }

        C02118() {
        }
    }

    
    class C02139 implements DialogInterface.OnClickListener {
        C02139() {
        }

        @Override 
        public void onClick(DialogInterface dialogInterface, int i) {
            final ProgressDialog show = ProgressDialog.show(SpeedTest_Activity.this, "Connecting Wifi", "Please wait...", true);
            ((WifiManager) SpeedTest_Activity.this.getApplicationContext().getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(true);
            new Handler().postDelayed(new Runnable() { 
                @Override 
                public void run() {
                    show.dismiss();
                }
            }, 3000L);
            SpeedTest_Activity.this.wf_flag = true;
            SpeedTest_Activity.this.wfSet();
        }
    }

    
    
    public class SpeedTestDownloadTask extends AsyncTask<String, Long, Long> {
        private boolean running;

        
        
        public class C05571 implements ProgressReportListener {
            Long[] data = new Long[3];
            long dl_Percentage = 0;
            long dlbits_last = 0;
            long ulbits_last = 0;

            @Override 
            public void reportCurrentUploadPercentage(long j) {
            }

            @Override 
            public void reportCurrentUploadSpeed(long j) {
            }

            C05571() {
            }

            @Override 
            public void reportCurrentDownloadSpeed(long j) {
                this.data[0] = Long.valueOf(j);
                this.data[1] = Long.valueOf(this.dl_Percentage);
                SpeedTestDownloadTask.this.publishProgress(this.data);
                this.dlbits_last = j;
            }

            @Override 
            public void reportCurrentDownloadProgress(long j) {
                this.data[0] = Long.valueOf(this.dlbits_last);
                this.data[1] = Long.valueOf(j);
                SpeedTestDownloadTask.this.publishProgress(this.data);
                this.dl_Percentage = j;
            }
        }

        private SpeedTestDownloadTask() {
            this.running = true;
        }

        @Override 
        protected void onCancelled() {
            this.running = false;
        }

        @Override 
        protected void onPreExecute() {
            SpeedTest_Activity.this.download.setTextColor(SpeedTest_Activity.this.getResources().getColor(R.color.Black));
            super.onPreExecute();
        }

        
        @Override 
        public Long doInBackground(String... strArr) {
            publishProgress(0L, 0L);
            SpeedTestMini speedTestMini = new SpeedTestMini(strArr[0], Integer.parseInt(strArr[1]));
            speedTestMini.setProgressReportListener(new C05571());
            try {
                speedTestMini.doDownloadtest();
                return 0L;
            } catch (IOException e) {
                e.printStackTrace();
                return 0L;
            }
        }

        
        @Override 
        public void onProgressUpdate(Long... lArr) {
            String str;
            double longValue = lArr[0].longValue();
            Log.d("Speed test",  " " + longValue);
            double d = longValue / 1000000.0d;
            if (longValue > 1000000.0d) {
                str = " Mbps";
                longValue = d;
            } else if (longValue > 1000.0d) {
                longValue /= 1000.0d;
                str = " Kbps";
            } else {
                str = " bits/sec";
            }
            SpeedTest_Activity.this.download.setText(String.format("%.2f", Double.valueOf(longValue)));
            SpeedTest_Activity.this.txt_dmb.setText(str);
            SpeedTest_Activity.this.gauge.setValue(d);
        }

        
        @Override 
        public void onPostExecute(Long l) {
            new SpeedTestUploadTask().execute(SpeedTest_Activity.this.host, "80");
            SpeedTest_Activity.this.download.setTextColor(SpeedTest_Activity.this.getResources().getColor(R.color.Black));
            SpeedTest_Activity.this.gauge.setValue(0.0d);
        }
    }

    
    private class SpeedTestLatency extends AsyncTask<String, Void, Long> {
        private boolean running;

        private SpeedTestLatency() {
            this.running = true;
        }

        @Override 
        protected void onCancelled() {
            this.running = false;
        }

        @Override 
        protected void onPreExecute() {
            SpeedTest_Activity.this.getString(R.string.ping);
            SpeedTest_Activity.this.getString(R.string.wait);
            SpeedTest_Activity.this.getString(R.string.download);
            SpeedTest_Activity.this.getString(R.string.upload);
            SpeedTest_Activity.this.buttonTest.startAnimation(SpeedTest_Activity.this.anim);
            super.onPreExecute();
        }

        
        @Override 
        public Long doInBackground(String... strArr) {
            long j = 0;
            for (int i = 0; i < 10; i++) {
                try {
                    j += (System.nanoTime() - System.nanoTime()) / 1000000;
                    new Socket(InetAddress.getByName(SpeedTest_Activity.this.host), 80).close();
                } catch (IOException e) {
                    Log.v("multiping", "Pinger80 " + e.toString());
                }
            }
            long j2 = j / 10;
            Log.d("pinnnggg1", String.valueOf(j2));
            return Long.valueOf(j2);
        }

        
        @Override 
        public void onPostExecute(Long l) {
            Log.d("pinnnggg", String.valueOf(l));
            super.onPostExecute(l);
            new SpeedTestDownloadTask().execute(SpeedTest_Activity.this.host, "80");
        }
    }

    
    
    public class SpeedTestUploadTask extends AsyncTask<String, Long, Long> {
        int cycle;
        private boolean running;
        double ul_avg;

        
        
        public class C05581 implements ProgressReportListener {
            long ul_Percentage = 0;
            long ulbits_last = 0;

            @Override 
            public void reportCurrentDownloadProgress(long j) {
            }

            @Override 
            public void reportCurrentDownloadSpeed(long j) {
            }

            C05581() {
            }

            @Override 
            public void reportCurrentUploadSpeed(long j) {
                SpeedTestUploadTask.this.publishProgress(Long.valueOf(j), Long.valueOf(this.ul_Percentage));
                this.ulbits_last = j;
                SpeedTestUploadTask.this.ul_avg += j;
                SpeedTestUploadTask.this.cycle++;
            }

            @Override 
            public void reportCurrentUploadPercentage(long j) {
                SpeedTestUploadTask.this.publishProgress(Long.valueOf(this.ulbits_last), Long.valueOf(j));
                this.ul_Percentage = j;
            }
        }

        private SpeedTestUploadTask() {
            this.running = true;
            this.ul_avg = 0.0d;
            this.cycle = 0;
        }

        @Override 
        protected void onCancelled() {
            this.running = false;
        }

        @Override 
        protected void onPreExecute() {
            SpeedTest_Activity.this.upload.setTextColor(SpeedTest_Activity.this.getResources().getColor(R.color.Black));
            super.onPreExecute();
        }

        
        @Override 
        public Long doInBackground(String... strArr) {
            publishProgress(0L, 0L);
            SpeedTestMini speedTestMini = new SpeedTestMini(strArr[0], Integer.parseInt(strArr[1]));
            speedTestMini.setProgressReportListener(new C05581());
            try {
                speedTestMini.doUploadtest();
                return 0L;
            } catch (IOException e) {
                e.printStackTrace();
                return 0L;
            }
        }

        
        @Override 
        public void onProgressUpdate(Long... lArr) {
            String str;
            double longValue = lArr[0].longValue();
            lArr[1].longValue();
            double d = longValue / 1000000.0d;
            if (longValue > 1000000.0d) {
                str = "Mbps";
                longValue = d;
            } else if (longValue > 1000.0d) {
                longValue /= 1000.0d;
                str = "Kbps";
            } else {
                str = "bits/sec";
            }
            SpeedTest_Activity.this.getString(R.string.upload);
            SpeedTest_Activity.this.upload.setText(String.format("%.2f", Double.valueOf(longValue)));
            SpeedTest_Activity.this.txt_umb.setText(str);
            SpeedTest_Activity.this.gauge.setValue(d);
        }

        
        @Override 
        public void onPostExecute(Long l) {
            SpeedTest_Activity.this.upload.setTextColor(SpeedTest_Activity.this.getResources().getColor(R.color.Black));
            SpeedTest_Activity.this.buttonTest.setEnabled(true);
            SpeedTest_Activity.this.buttonTest.clearAnimation();
            SpeedTest_Activity.this.buttonTest.setText(SpeedTest_Activity.this.getResources().getString(R.string.test_again));
            SpeedTest_Activity.this.gauge.setValue(0.0d);
        }
    }

    
    @Override 
    public void onResume() {
        super.onResume();
    }

    public void mbSet() {
        setTextView();
        if (this.flag_wf_set) {
            return;
        }
        setTextView();
        this.flag_wf_set = true;
        this.flag_mb_set = false;
    }

    public void wfSet() {
        if (this.flag_mb_set) {
            return;
        }
        setTextView();
        this.flag_wf_set = false;
        this.flag_mb_set = true;
    }

    @Override 
    public void onDestroy() {
        super.onDestroy();
    }

    protected void showErrorConnection() {
        new AlertDialog.Builder(this).setTitle("Network Error").setOnCancelListener(new DialogInterface.OnCancelListener() { 
            @Override 
            public void onCancel(DialogInterface dialogInterface) {
                SpeedTest_Activity.this.finish();
            }
        }).setMessage("Please Check Your Internet Connection and Try Again").setCancelable(true).setNeutralButton("OK", new DialogInterface.OnClickListener() { 
            @Override 
            public void onClick(DialogInterface dialogInterface, int i) {
                SpeedTest_Activity.this.finish();
            }
        }).show();
    }

    @Override 
    public boolean onKeyDown(int i, KeyEvent keyEvent) {
        if (i == 4) {
            finish();
            return true;
        }
        return true;
    }

    private void ReadDataFromDB() {
        Volley.newRequestQueue(this).add(new StringRequest(1, "http://ip-api.com/json", new Response.Listener<String>() { 
            @Override 
            public void onResponse(String str) {
                try {
                    JSONObject jSONObject = new JSONObject(str);
                    SpeedTest_Activity.this.country = jSONObject.getString(ServerDbHelper.COUNTRY_CLSTR);
                    PrintStream printStream = System.out;
                    printStream.println("Country :::: " + SpeedTest_Activity.this.country);
                    PrintStream printStream2 = System.out;
                    printStream2.println("Country :::: " + SpeedTest_Activity.this.country);
                    PrintStream printStream3 = System.out;
                    printStream3.println("Country :::: " + SpeedTest_Activity.this.country);
                    PrintStream printStream4 = System.out;
                    printStream4.println("Country :::: " + SpeedTest_Activity.this.country);
                    PrintStream printStream5 = System.out;
                    printStream5.println("Country :::: " + SpeedTest_Activity.this.country);
                    SpeedTest_Activity speedTest_Activity = SpeedTest_Activity.this;
                    speedTest_Activity.setServer(speedTest_Activity.country);
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
        }, new Response.ErrorListener() { 
            @Override 
            public void onErrorResponse(VolleyError volleyError) {
                Toast makeText = Toast.makeText(SpeedTest_Activity.this.getApplicationContext(), volleyError.getMessage(), Toast.LENGTH_LONG);
                makeText.setGravity(17, 0, 0);
                makeText.show();
            }
        }) { 
            @Override 
            protected Map<String, String> getParams() throws AuthFailureError {
                return new HashMap();
            }
        });
    }

    private String getStringResourceByName(String str) {
        int identifier;
        String packageName = getPackageName();


        try {
            Log.e("MYTAG", "ErrorNo: getStringResourceByName: " +str);
            identifier = getResources().getIdentifier(str, "string", packageName);
        } catch (Exception unused) {
            Log.e("MYTAG", "ErrorNo: getStringResourceByName: other");
            identifier = getResources().getIdentifier("other", "string", packageName);
        }
        return getString(identifier);
    }

    public void setServer(String str) {
        this.host = getStringResourceByName(str.replaceAll("\\s", "").replaceAll("-", "").toLowerCase());
        PrintStream printStream = System.out;
        printStream.println("HOST :::: " + this.host);
        PrintStream printStream2 = System.out;
        printStream2.println("HOST :::: " + this.host);
        PrintStream printStream3 = System.out;
        printStream3.println("HOST :::: " + this.host);
        PrintStream printStream4 = System.out;
        printStream4.println("HOST :::: " + this.host);
        PrintStream printStream5 = System.out;
        printStream5.println("HOST :::: " + this.host);
    }

    public void setTextView() {
        this.download.setText("0");
        this.upload.setText("0");
        this.buttonTest.setText(getResources().getString(R.string.start_test));
    }
}
