package com.demo.whousemywifi.whousewifi;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.Uri;
import android.net.wifi.SupplicantState;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.widget.Toast;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.AppCompatTextView;
import androidx.appcompat.widget.Toolbar;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
  
  
 
 

import java.util.ArrayList;
import java.util.List;

import com.demo.whousemywifi.AdAdmob;
import com.demo.whousemywifi.R;

import com.demo.whousemywifi.common.PrefManager;
import com.demo.whousemywifi.whousewifi.interfaces.OnDeviceFoundListener;
import com.demo.whousemywifi.whousewifi.models.DeviceItem;
import com.demo.whousemywifi.whousewifi.models.DeviceModal;


public class WhoUseWiFiMainActivity extends AppCompatActivity {
   
    DeviceAdapter deviceAdapter;
    private final ArrayList<DeviceModal> devices = new ArrayList<>();
    private long end;
    AppCompatTextView getway_name;
    RelativeLayout layout;
    PrefManager prefManager;
    RecyclerView rv_device_list;
    Button scanhost;
    
    private long start;
    Toolbar toolbar;





    @Override 
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        try {
            setContentView(R.layout.activity_who_use_wifi_users);


            AdAdmob adAdmob = new AdAdmob( this);
            adAdmob.BannerAd((RelativeLayout) findViewById(R.id.banner), this);
            adAdmob.FullscreenAd_Counter(this);




            Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
            this.toolbar = toolbar;
            setSupportActionBar(toolbar);
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);
            getSupportActionBar().setHomeButtonEnabled(true);
            getSupportActionBar().setDisplayShowTitleEnabled(false);
            getSupportActionBar().setHomeAsUpIndicator(R.drawable.toolbar_back_black_dark_icon);
            
            
           
            
            PrefManager prefManager = new PrefManager(this);
            this.prefManager = prefManager;
            this.getway_name = (AppCompatTextView) findViewById(R.id.getway_name);
            WifiInfo connectionInfo = ((WifiManager) getApplicationContext().getSystemService(Context.WIFI_SERVICE)).getConnectionInfo();
            if (connectionInfo.getSupplicantState() == SupplicantState.COMPLETED) {
                this.getway_name.setText(connectionInfo.getSSID());
            }
            RecyclerView recyclerView = (RecyclerView) findViewById(R.id.rv_device_list);
            this.rv_device_list = recyclerView;
            recyclerView.setLayoutManager(new LinearLayoutManager(getApplicationContext(), RecyclerView.VERTICAL, false));
            this.scanhost = (Button) findViewById(R.id.scanhost);
            DeviceAdapter deviceAdapter = new DeviceAdapter(this, this.devices);
            this.deviceAdapter = deviceAdapter;
            this.rv_device_list.setAdapter(deviceAdapter);
            final ProgressDialog progressDialog = new ProgressDialog(this);
            progressDialog.setMessage("Scanning, please wait.");
            final DeviceFinder deviceFinder = new DeviceFinder(this, new OnDeviceFoundListener() { 
                @Override 
                public void onFailed(DeviceFinder deviceFinder2, int i) {
                }

                @Override 
                public void onStart(DeviceFinder deviceFinder2) {
                    WhoUseWiFiMainActivity.this.devices.clear();
                    progressDialog.show();
                    WhoUseWiFiMainActivity.this.start = System.currentTimeMillis();
                }

                @Override 
                public void onFinished(DeviceFinder deviceFinder2, List<DeviceItem> list) {
                    WhoUseWiFiMainActivity.this.end = System.currentTimeMillis();
                    long unused = WhoUseWiFiMainActivity.this.end;
                    long unused2 = WhoUseWiFiMainActivity.this.start;
                    try {
                        if (list.size() > 0) {
                            for (DeviceItem deviceItem : list) {
                                if (deviceItem != null) {
                                    DeviceModal deviceModal = new DeviceModal();
                                    if (deviceItem.getDeviceName() != null) {
                                        deviceModal.setDeviceName(deviceItem.getDeviceName());
                                    }
                                    if (deviceItem.getIpAddress() != null) {
                                        deviceModal.setIpAddress(deviceItem.getIpAddress());
                                    }
                                    if (deviceItem.getVendorName() != null) {
                                        deviceModal.setVendorName(deviceItem.getVendorName());
                                    }
                                    if (deviceItem.getMacAddress() != null) {
                                        deviceModal.setMacAddress(deviceItem.getMacAddress());
                                    }
                                    WhoUseWiFiMainActivity.this.devices.add(deviceModal);
                                }
                            }
                        }
                        WhoUseWiFiMainActivity.this.deviceAdapter.notifyDataSetChanged();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    progressDialog.dismiss();
                }
            });
            deviceFinder.setTimeout(1500).start();
            this.scanhost.setOnClickListener(new View.OnClickListener() { 
                @Override 
                public void onClick(View view) {
                    WhoUseWiFiMainActivity.this.devices.clear();
                    WhoUseWiFiMainActivity.this.deviceAdapter.notifyDataSetChanged();
                    deviceFinder.setTimeout(1500).start();
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override 
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override 
    public boolean onOptionsItemSelected(MenuItem menuItem) {
        switch (menuItem.getItemId()) {
            case 16908332:
                onBackPressed();
                return true;


            case R.id.rate :
                if (isOnline()) {
                    Intent intent3 = new Intent("android.intent.action.VIEW", Uri.parse("http://play.google.com/store/apps/details?id=" + getPackageName()));
                    intent3.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    intent3.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(intent3);
                } else {
                    Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                }
                return true;
            case R.id.share :
                if (isOnline()) {
                    Intent intent4 = new Intent("android.intent.action.SEND");
                    intent4.setType("text/plain");
                    intent4.putExtra("android.intent.extra.TEXT", "Hi! I'm using a Who Use My Wi-Fi application. Check it out:http://play.google.com/store/apps/details?id=" + getPackageName());
                    intent4.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(Intent.createChooser(intent4, "Share with Friends"));
                } else {
                    Toast makeText2 = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText2.setGravity(17, 0, 0);
                    makeText2.show();
                }
                return true;
            default:
                return super.onOptionsItemSelected(menuItem);
        }
    }

    public boolean isOnline() {
        android.net.NetworkInfo activeNetworkInfo = ((ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
        return activeNetworkInfo != null && activeNetworkInfo.isConnectedOrConnecting();
    }
}
