package com.demo.whousemywifi.wifiInfo;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.ConnectivityManager;
import android.net.DhcpInfo;
import android.net.NetworkInfo;
import android.net.Uri;
import android.net.wifi.WifiManager;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.StrictMode;
import android.text.format.Formatter;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Toast;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.AppCompatTextView;
import androidx.appcompat.widget.Toolbar;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.localbroadcastmanager.content.LocalBroadcastManager;


import java.io.IOException;
import java.io.PrintStream;
import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;
import java.util.Objects;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;
import org.jsoup.Jsoup;
import org.jsoup.select.Elements;

import com.demo.whousemywifi.AdAdmob;
import com.demo.whousemywifi.AppUtils;
import com.demo.whousemywifi.R;

import com.demo.whousemywifi.common.PrefManager;
import com.demo.whousemywifi.ipInfo.ConnectivityReceiver;
import com.demo.whousemywifi.ipInfo.IpInformation;
import com.demo.whousemywifi.wifiList.WifiListActivity;
import com.demo.whousemywifi.wifiStrenghth.WifiStrengthMainActivity;


public class WiFiInfoMainActivity extends AppCompatActivity {
    private static final int PERMISSION_REQUEST_CODE = 1;
    Activity activity;
   
    Context context;
    ConnectivityReceiver cr;
    DhcpInfo d;
    String externalip;
    String internalip;
    RelativeLayout layout;
    LinearLayout linIPInfo;
    LinearLayout linWiFiInfo;
    LinearLayout linWiFiStrength;
    LinearLayout linWifiList;
    PrefManager prefManager;
    String s_gateway;
    
    Toolbar toolbar;
    AppCompatTextView txtExternalIP;
    AppCompatTextView txtGateway;
    AppCompatTextView txtLocalIp;
    WifiManager wifii;

    private boolean checkPermission() {
        return ContextCompat.checkSelfPermission(this.context, "android.permission.ACCESS_FINE_LOCATION") == 0 || ContextCompat.checkSelfPermission(this.context, "android.permission.ACCESS_COARSE_LOCATION") == 0;
    }

    private void requestPermission() {
        ActivityCompat.requestPermissions(this.activity, new String[]{"android.permission.ACCESS_FINE_LOCATION", "android.permission.ACCESS_COARSE_LOCATION"}, 1);
    }

    @Override 
    public void onRequestPermissionsResult(int i, String[] strArr, int[] iArr) {
        super.onRequestPermissionsResult(i, strArr, iArr);
        if (i != 1) {
            return;
        }
        if (iArr.length <= 0 || iArr[0] != 0) {
            int i2 = iArr[1];
        }
    }

    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override 
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override 
    public boolean onOptionsItemSelected(MenuItem menuItem) {
        switch (menuItem.getItemId()) {
            case 16908332:
                onBackPressed();
                return true;
           

            case R.id.rate :
                if (isOnline()) {
                    Intent intent3 = new Intent("android.intent.action.VIEW", Uri.parse("http://play.google.com/store/apps/details?id=" + getPackageName()));
                    intent3.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    intent3.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(intent3);
                } else {
                    Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                }
                return true;
            case R.id.share :
                if (isOnline()) {
                    Intent intent4 = new Intent("android.intent.action.SEND");
                    intent4.setType("text/plain");
                    intent4.putExtra("android.intent.extra.TEXT", "Hi! I'm using a Who Use My Wi-Fi application. Check it out:http://play.google.com/store/apps/details?id=" + getPackageName());
                    intent4.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(Intent.createChooser(intent4, "Share with Friends"));
                } else {
                    Toast makeText2 = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText2.setGravity(17, 0, 0);
                    makeText2.show();
                }
                return true;
            default:
                return super.onOptionsItemSelected(menuItem);
        }
    }

    public boolean isOnline() {
        NetworkInfo activeNetworkInfo = ((ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
        return activeNetworkInfo != null && activeNetworkInfo.isConnectedOrConnecting();
    }

 



    
    @Override 
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        setContentView(R.layout.activity_wi_fi_info_main);


        AdAdmob adAdmob = new AdAdmob( this);
        adAdmob.BannerAd((RelativeLayout) findViewById(R.id.banner), this);
        adAdmob.FullscreenAd_Counter(this);

        this.context = this;
        this.activity = this;
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        this.toolbar = toolbar;
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowTitleEnabled(false);
        getSupportActionBar().setHomeAsUpIndicator(R.drawable.toolbar_back_black_dark_icon);
        
        
       
        
        PrefManager prefManager = new PrefManager(this);
        this.prefManager = prefManager;
        this.txtLocalIp = (AppCompatTextView) findViewById(R.id.txtLocalIp);
        this.txtGateway = (AppCompatTextView) findViewById(R.id.txtGateway);
        this.txtExternalIP = (AppCompatTextView) findViewById(R.id.txtExternalIP);
        this.linWiFiStrength = (LinearLayout) findViewById(R.id.linWiFiStrength);
        this.linWiFiInfo = (LinearLayout) findViewById(R.id.linWiFiInfo);
        this.linWifiList = (LinearLayout) findViewById(R.id.linWifiList);
        this.linIPInfo = (LinearLayout) findViewById(R.id.linIPInfo);
        if (Build.VERSION.SDK_INT >= 24) {
            registerReceiver(this.cr, new IntentFilter("android.net.conn.CONNECTIVITY_CHANGE"));
        }
        this.wifii = (WifiManager) getApplicationContext().getSystemService(Context.WIFI_SERVICE);
        try {
            StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().permitAll().build());
        } catch (Exception e) {
            e.printStackTrace();
        }
        this.linWiFiStrength.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Intent intent = new Intent(WiFiInfoMainActivity.this, WifiStrengthMainActivity.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                WiFiInfoMainActivity.this.startActivity(intent);
            }
        });
        this.linWiFiInfo.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Intent intent = new Intent(WiFiInfoMainActivity.this, WifiInformationMainActivity.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                WiFiInfoMainActivity.this.startActivity(intent);
            }
        });
        this.linWifiList.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Intent intent = new Intent(WiFiInfoMainActivity.this, WifiListActivity.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                WiFiInfoMainActivity.this.startActivity(intent);
            }
        });
        this.linIPInfo.setOnClickListener(new View.OnClickListener() { 
            @Override 
            public void onClick(View view) {
                Intent intent = new Intent(WiFiInfoMainActivity.this, IpInformation.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                WiFiInfoMainActivity.this.startActivity(intent);
            }
        });
    }

    
    @Override 
    public void onResume() {
        super.onResume();
        if (Build.VERSION.SDK_INT >= 23) {
            if (checkPermission()) {
                new getWifiDetailsTask().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, new Void[0]);
                checkConnection();
                return;
            }
            requestPermission();
            return;
        }
        new getWifiDetailsTask().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, new Void[0]);
        checkConnection();
    }

    
    
    public class getWifiDetailsTask extends AsyncTask<Void, Void, Void> {
        private getWifiDetailsTask() {
        }

        @Override 
        public void onPreExecute() {
            super.onPreExecute();
        }

        @Override 
        public Void doInBackground(Void... voidArr) {
            try {
                try {
                    Response execute = new OkHttpClient().newCall(new Request.Builder().url("https://api.ipify.org/").build()).execute();
                    WiFiInfoMainActivity.this.externalip = execute.body().string().trim();
                } catch (Exception e) {
                    WiFiInfoMainActivity.this.externalip = "";
                    e.printStackTrace();
                } catch (Throwable th) {
                    th.printStackTrace();
                    return null;
                }
            } catch (Exception unused) {
                Elements select = null;
                try {
                    select = Jsoup.connect("http://checkip.amazonaws.com/").ignoreContentType(true).get().select("body");
                } catch (IOException e) {
                    e.printStackTrace();
                }
                WiFiInfoMainActivity.this.externalip = select.text().trim();
            }
            return null;
        }

        @Override 
        public void onPostExecute(Void r1) {
            try {
                WiFiInfoMainActivity.this.loadWifiInfoData();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private void checkConnection() {
        showSnack(ConnectivityReceiver.isConnected());
    }

    private void showSnack(boolean z) {
        if (z) {
            new getWifiDetailsTask().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, new Void[0]);
            return;
        }
        Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection", Toast.LENGTH_SHORT);
        makeText.setGravity(17, 0, 0);
        makeText.show();
    }

    public void loadWifiInfoData() {
        boolean z;
        try {
            this.internalip = Formatter.formatIpAddress(this.wifii.getConnectionInfo().getIpAddress());
            try {
                ConnectivityManager connectivityManager = (ConnectivityManager) getApplicationContext().getSystemService(Context.CONNECTIVITY_SERVICE);
                boolean z2 = false;
                if (connectivityManager != null) {
                    NetworkInfo networkInfo = connectivityManager.getNetworkInfo(0);
                    Objects.requireNonNull(networkInfo);
                    NetworkInfo networkInfo2 = networkInfo;
                    z = networkInfo.isConnectedOrConnecting();
                } else {
                    z = false;
                }
                if (connectivityManager != null) {
                    NetworkInfo networkInfo3 = connectivityManager.getNetworkInfo(1);
                    Objects.requireNonNull(networkInfo3);
                    NetworkInfo networkInfo4 = networkInfo3;
                    z2 = networkInfo3.isConnectedOrConnecting();
                }
                PrintStream printStream = System.out;
                printStream.println(z + " net " + z2);
                if (z) {
                    Object systemService = getApplicationContext().getSystemService(Context.WIFI_SERVICE);
                    Objects.requireNonNull(systemService);
                    ((WifiManager) systemService).getConnectionInfo().getRssi();
                    this.internalip = getIpAddress();
                    AppUtils.isConnected(getApplicationContext());
                } else if (z2) {
                    DhcpInfo dhcpInfo = this.wifii.getDhcpInfo();
                    this.d = dhcpInfo;
                    this.s_gateway = String.valueOf(Formatter.formatIpAddress(dhcpInfo.gateway));
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            AppCompatTextView appCompatTextView = this.txtLocalIp;
            appCompatTextView.setText("Local ip : " + this.internalip);
            AppCompatTextView appCompatTextView2 = this.txtExternalIP;
            appCompatTextView2.setText("" + this.externalip);
            AppCompatTextView appCompatTextView3 = this.txtGateway;
            appCompatTextView3.setText("" + this.s_gateway);
        } catch (Exception e2) {
            e2.printStackTrace();
        }
    }

    public static String getIpAddress() {
        try {
            Enumeration<NetworkInterface> networkInterfaces = NetworkInterface.getNetworkInterfaces();
            if (!networkInterfaces.hasMoreElements()) {
                return null;
            }
            Enumeration<InetAddress> inetAddresses = networkInterfaces.nextElement().getInetAddresses();
            while (true) {
                if (inetAddresses.hasMoreElements()) {
                    InetAddress nextElement = inetAddresses.nextElement();
                    if (!nextElement.isLoopbackAddress() && (nextElement instanceof Inet4Address)) {
                        String hostAddress = nextElement.getHostAddress();
                        Log.e("IP address", "" + hostAddress);
                        Log.i("TAG", "getIpAddress: " + hostAddress);
                        return hostAddress;
                    }
                }
            }
        } catch (SocketException e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override 
    public void onDestroy() {
        super.onDestroy();
        try {
            if (this.cr != null) {
                LocalBroadcastManager.getInstance(this).unregisterReceiver(this.cr);
                this.cr = null;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
