package com.demo.whousemywifi.wifiList;

import android.Manifest;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.os.Build;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.os.Parcelable;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.core.app.ActivityCompat;
import androidx.core.app.NotificationManagerCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;


import com.demo.whousemywifi.AdAdmob;
import com.demo.whousemywifi.R;


public class WifiListActivity extends AppCompatActivity {
    Activity activity;
    Context context;
    public CountDownTimer countDownTimerGeneral;
    private Parcelable posicionRecycler;
    Toolbar toolbar;
    public TextView txtSearchingWifi;
    private WifiListAdapter wifiListAdapter;
    public RecyclerView wifiListRecyclerView;
    public ArrayList<ModalClass> wifiLists;
    private WifiManager wifiManager;

    public int calculateSignalLevel(int i, int i2) {
        if (i <= -100) {
            return 0;
        }
        if (i >= -50) {
            return i2 - 1;
        }
        return (int) (((i - (-100)) * (i2 - 1)) / 50.0f);
    }

    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override 
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override 
    public boolean onOptionsItemSelected(MenuItem menuItem) {
        switch (menuItem.getItemId()) {
            case 16908332:
                onBackPressed();
                return true;

            case R.id.rate :
                if (isOnline()) {
                    Intent intent3 = new Intent("android.intent.action.VIEW", Uri.parse("http://play.google.com/store/apps/details?id=" + getPackageName()));
                    intent3.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    intent3.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(intent3);
                } else {
                    Toast makeText = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText.setGravity(17, 0, 0);
                    makeText.show();
                }
                return true;
            case R.id.share :
                if (isOnline()) {
                    Intent intent4 = new Intent("android.intent.action.SEND");
                    intent4.setType("text/plain");
                    intent4.putExtra("android.intent.extra.TEXT", "Hi! I'm using a Who Use My Wi-Fi application. Check it out:http://play.google.com/store/apps/details?id=" + getPackageName());
                    intent4.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                    startActivity(Intent.createChooser(intent4, "Share with Friends"));
                } else {
                    Toast makeText2 = Toast.makeText(getApplicationContext(), "No Internet Connection..", Toast.LENGTH_SHORT);
                    makeText2.setGravity(17, 0, 0);
                    makeText2.show();
                }
                return true;
            default:
                return super.onOptionsItemSelected(menuItem);
        }
    }

    public boolean isOnline() {
        NetworkInfo activeNetworkInfo = ((ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
        return activeNetworkInfo != null && activeNetworkInfo.isConnectedOrConnecting();
    }

    
    @Override
    
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        setContentView(R.layout.wifi_list_activity_1);

        AdAdmob adAdmob = new AdAdmob( this);
        adAdmob.BannerAd((RelativeLayout) findViewById(R.id.banner), this);
        adAdmob.FullscreenAd_Counter(this);

        this.context = this;
        this.activity = this;
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        this.toolbar = toolbar;
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayShowTitleEnabled(false);
        getSupportActionBar().setHomeAsUpIndicator(R.drawable.toolbar_back_black_dark_icon);
        solicitarPermisos();
        this.wifiListRecyclerView = (RecyclerView) findViewById(R.id.wifiListRecyclerView);
        this.txtSearchingWifi = (TextView) findViewById(R.id.txtSearchingWifi);
        this.wifiListRecyclerView.setLayoutManager(new LinearLayoutManager(this));
        this.wifiLists = new ArrayList<>();
        procesoActualizacionRedes();
    }

    
    public class WifiListAdapter extends RecyclerView.Adapter<WifiListAdapter.ViewHolder> implements View.OnClickListener {
        public ArrayList<ModalClass> listaRedes;
        private View.OnClickListener listener;
        int val = 1;

        public int setImage(int i) {
            switch (i) {
                case 1:
                    this.val++;
                    return R.drawable.color_1;
                case 2:
                    this.val++;
                    return R.drawable.color_2;
                case 3:
                    this.val++;
                    return R.drawable.color_3;
                case 4:
                    this.val++;
                    return R.drawable.color_4;
                case 5:
                    this.val++;
                    return R.drawable.color_5;
                case 6:
                    this.val = 1;
                    return R.drawable.color_6;
                default:
                    return R.drawable.color_1;
            }
        }

        
        public class ViewHolder extends RecyclerView.ViewHolder {
            ProgressBar barraPorcentaje;
            TextView canal;
            TextView frecuencia;
            LinearLayout linBorderView;
            TextView nombreRedYDireccionMac;
            TextView porcentaje;
            TextView rssi;
            TextView seguridad;

            public ViewHolder(View view) {
                super(view);
                this.nombreRedYDireccionMac = (TextView) view.findViewById(R.id.txtNombreRedYDireccionMac);
                this.frecuencia = (TextView) view.findViewById(R.id.txtFrecuencia);
                this.canal = (TextView) view.findViewById(R.id.txtCanal);
                this.seguridad = (TextView) view.findViewById(R.id.txtSeguridad);
                this.porcentaje = (TextView) view.findViewById(R.id.txtPorcentaje);
                this.rssi = (TextView) view.findViewById(R.id.txtRssi);
                this.barraPorcentaje = (ProgressBar) view.findViewById(R.id.barraPorcentaje);
                this.linBorderView = (LinearLayout) view.findViewById(R.id.linBorderView);
            }
        }

        public WifiListAdapter(ArrayList<ModalClass> arrayList) {
            this.listaRedes = arrayList;
        }

        @Override 
        public ViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
            View inflate = LayoutInflater.from(viewGroup.getContext()).inflate(R.layout.wifi_list_layout_list1, viewGroup, false);
            ViewHolder viewHolder = new ViewHolder(inflate);
            inflate.setOnClickListener(this);
            return viewHolder;
        }

        @Override 
        public void onBindViewHolder(ViewHolder viewHolder, int i) {
            viewHolder.linBorderView.setBackgroundResource(setImage(this.val));
            viewHolder.nombreRedYDireccionMac.setText(this.listaRedes.get(i).getNombreRedYDireccionMac());
            TextView textView = viewHolder.frecuencia;
            textView.setText("Frequency: " + " " + this.listaRedes.get(i).getFrecuencia() + " MHz");
            TextView textView2 = viewHolder.canal;
            textView2.setText("Channel: " + " " + this.listaRedes.get(i).getCanal());
            TextView textView3 = viewHolder.seguridad;
            textView3.setText("Security: " + " " + this.listaRedes.get(i).getSeguridad());
            TextView textView4 = viewHolder.porcentaje;
            textView4.setText(this.listaRedes.get(i).getPorcentaje() + "%");
            TextView textView5 = viewHolder.rssi;
            textView5.setText(this.listaRedes.get(i).getRssi() + " dBm");
            viewHolder.barraPorcentaje.setProgress(this.listaRedes.get(i).getPorcentaje());
        }

        @Override 
        public int getItemCount() {
            return this.listaRedes.size();
        }

        @Override 
        public void onClick(View view) {
            View.OnClickListener onClickListener = this.listener;
            if (onClickListener != null) {
                onClickListener.onClick(view);
            }
        }

        public void setOnClickListener(View.OnClickListener onClickListener) {
            this.listener = onClickListener;
        }
    }

    private void solicitarPermisos() {
        ActivityCompat.requestPermissions(this, new String[]{"android.permission.ACCESS_COARSE_LOCATION"}, 1);
    }

    @Override
    
    public void onDestroy() {
        super.onDestroy();
        CountDownTimer countDownTimer = this.countDownTimerGeneral;
        if (countDownTimer != null) {
            countDownTimer.cancel();
        }
    }

    public void actualizarRedes(int i) {
        this.countDownTimerGeneral = new CountDownTimer(60000, i) { 
            @Override 
            public void onTick(long j) {
                try {
                    WifiListActivity.this.procesoActualizacionRedes();
                } catch (SecurityException unused) {
                }
            }

            @Override 
            public void onFinish() {
                WifiListActivity.this.procesoActualizacionRedes();
                WifiListActivity.this.countDownTimerGeneral.start();
            }
        }.start();
    }

    public void procesoActualizacionRedes() {
        this.wifiLists.clear();
        try {
            this.posicionRecycler = this.wifiListRecyclerView.getLayoutManager().onSaveInstanceState();
        } catch (Exception unused) {
        }
        this.wifiManager = (WifiManager) getApplicationContext().getSystemService(Context.WIFI_SERVICE);
        int i = Build.VERSION.SDK_INT;
        try {
            this.wifiManager.startScan();
        } catch (Exception unused2) {
        }
        try {
            String str = "";
            String str2 = str;
            if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
                
                
                
                
                
                
                
                return;
            }
            for (ScanResult scanResult : this.wifiManager.getScanResults()) {
                String replace = scanResult.SSID.replace("\"", "");
                String upperCase = scanResult.BSSID.toUpperCase();
                String obtenerSeguridadRed = obtenerSeguridadRed(scanResult.capabilities);
                int i2 = scanResult.level;
                int calculateSignalLevel = calculateSignalLevel(scanResult.level, 101);
                if (Build.VERSION.SDK_INT >= 21) {
                    str = String.valueOf(scanResult.frequency);
                    str2 = String.valueOf(getCanal(scanResult.frequency));
                }
                this.wifiLists.add(new ModalClass(replace, upperCase, replace + " [" + upperCase + "]", str, str2, obtenerSeguridadRed, i2, calculateSignalLevel));
            }
        } catch (NullPointerException unused3) {
        }
        if (!this.wifiLists.isEmpty()) {
            this.txtSearchingWifi.setVisibility(View.GONE);
            iniciarAdaptador();
            try {
                this.wifiListRecyclerView.getLayoutManager().onRestoreInstanceState(this.posicionRecycler);
                return;
            } catch (Exception unused4) {
                return;
            }
        }
        this.txtSearchingWifi. setVisibility(View.VISIBLE);
        iniciarAdaptador();
    }

    public String obtenerSeguridadRed(String str) {
        CharSequence[] charSequenceArr = {"WEP", "WPA", "WPA2", "WPA-EAP", "IEEE8021X"};
        for (int i = 4; i >= 0; i--) {
            if (str.contains(charSequenceArr[i])) {
                return (String) charSequenceArr[i];
            }
        }
        return "Open";
    }

    public int getCanal(int i) {
        if (i == 2484) {
            return 14;
        }
        if (i < 2484) {
            return (i - 2407) / 5;
        }
        return (i / 5) + NotificationManagerCompat.IMPORTANCE_UNSPECIFIED;
    }

    public void iniciarAdaptador() {
        Collections.sort(this.wifiLists, new Comparator<ModalClass>() { 
            @Override 
            public int compare(ModalClass modalClass, ModalClass modalClass2) {
                if (modalClass.getRssi() < modalClass2.getRssi()) {
                    return 1;
                }
                return modalClass.getRssi() > modalClass2.getRssi() ? -1 : 0;
            }
        });
        WifiListAdapter wifiListAdapter = new WifiListAdapter(this.wifiLists);
        this.wifiListAdapter = wifiListAdapter;
        this.wifiListRecyclerView.setAdapter(wifiListAdapter);
    }
}
